var on_use = false

function draw_bbox(evt)
{
	bbox = evt.target.getBBox()
	var node = svgdoc.createElementNS('http://www.w3.org/2000/svg' , "rect")
	node.setAttribute("x" , bbox.x)
	node.setAttribute("y" , bbox.y)
	node.setAttribute("width" , bbox.width)
	node.setAttribute("height" , bbox.height)
	node.setAttribute("fill" , "none")
	node.setAttribute("stroke" , "black")
	evt.target.ownerDocument.getElementById("gr").appendChild(node)
}

function get_length(evt)
{
	MyPath = evt.target.ownerDocument.getElementById("p")
	alert("Curve's length is " + MyPath.getTotalLength() + " units")
}

function put_middle(evt)
{
	MyPath = evt.target.ownerDocument.getElementById("p")
	MyPath_length = MyPath.getTotalLength()
	MySVGPoint = MyPath.getPointAtLength(MyPath_length / 2)
	MyMiddle = evt.target.ownerDocument.getElementById("middle")
	MyMiddle.setAttributeNS(null,"cx",MySVGPoint.x)
	MyMiddle.setAttributeNS(null,"cy",MySVGPoint.y)
	MyMiddle.setAttributeNS(null,"visibility","visible")
}

function pause_anim(evt)
{
	evt.target.ownerDocument.rootElement.pauseAnimations()
}

function unpause_anim(evt)
{
	evt.target.ownerDocument.rootElement.unpauseAnimations()
}

function zoom(evt,factor)
{
	old_factor = evt.target.ownerDocument.rootElement.currentScale
	evt.target.ownerDocument.rootElement.currentScale = old_factor * factor
}

function pan(evt,direction)
{
	svgroot = evt.target.ownerDocument.rootElement
	switch(direction)
	{
		case 0 : svgroot.currentTranslate.y = svgroot.currentTranslate.y - 50;break;
		case 1 : svgroot.currentTranslate.y = svgroot.currentTranslate.y + 50;break;
		case 2 : svgroot.currentTranslate.x = svgroot.currentTranslate.x - 50;break;
		case 3 : svgroot.currentTranslate.x = svgroot.currentTranslate.x + 50;break;
	}
}

function get_screenctm(evt)
{
	matrix = evt.target.ownerDocument.rootElement.getScreenCTM().inverse()
	x = matrix.a * evt.clientX + matrix.c * evt.clientY + matrix.e
	y = matrix.b * evt.clientX + matrix.d * evt.clientY + matrix.f
	alert("clientX : " + evt.clientX +"\nclientY : " + evt.clientY + "\nx_svg : " + x + "\ny_svg : " + y)
}

function set_time(evt)
{
	time = new Date()
	time_seconds = time.getHours()*3600 + time.getMinutes()*60 + time.getSeconds()
	evt.target.ownerDocument.rootElement.setCurrentTime(time_seconds)
}

function reset_time(evt)
{
	evt.target.ownerDocument.rootElement.setCurrentTime(0)
}

function get_time(evt)
{
	time_elapsed = evt.target.ownerDocument.rootElement.getCurrentTime()
	alert("Timeline start " + parseInt(time_elapsed) + " seconds ago")
}

function get_corresp(evt)
{
	alert(printNode(evt.target.correspondingElement))
}

function get_use(evt)
{
	alert(printNode(evt.target.correspondingUseElement))
}

function create_point(evt)
{
	node = evt.target.ownerDocument.getElementById("MyText")
	point = evt.target.ownerDocument.rootElement.createSVGPoint()
	point.x = 300
	point.y = 395
	alert("Letter at 300 , 395 is at range " + node.getCharNumAtPosition(point) + " in string")
}

function create_matrix(evt)
{
	matrix = evt.target.ownerDocument.rootElement.createSVGMatrix()
	matrix = matrix.translate(110,425)
	matrix = matrix.flipX()
	str = "matrix("+matrix.a+" "+matrix.b+" "+matrix.c+" "+matrix.d+" "+matrix.e+" "+matrix.f+")"
	evt.target.ownerDocument.getElementById("MyGroup").setAttributeNS(null,"transform",str)
}

function get_svg(evt)
{
	str = "Nearest svg element :\nwidth : " + evt.target.viewportElement.getAttributeNS(null,"width")
	str += "\nheight : " + evt.target.viewportElement.getAttributeNS(null,"height")
	alert(str)
}

function get_root(evt)
{
	if (on_use)
	{
		if (evt.target.animatedInstanceRoot)
			alert(printNode(evt.target.animatedInstanceRoot.correspondingElement))
		else
			alert("evt.target.animatedInstanceRoot don't exist")
	}
	on_use = false
}

function is_on_use(evt)
{
	on_use = true
}

function mouse_over2(evt,time_after)
{
evt.target.ownerDocument.getElementById("anim").beginElementAt(time_after)
}

function mouse_out(evt)
{
evt.target.ownerDocument.getElementById("anim").endElement()
}

function mouse_over(evt)
{
evt.target.ownerDocument.getElementById("anim").beginElement()
}

function mouse_out2(evt,time_after)
{
evt.target.ownerDocument.getElementById("anim").endElementAt(time_after)
}
